Subject: Re: SunOS 4.1.1 wu-ftpd-2.4 nfs mounted uploads

From: Pete Glassenbury <[email-masked]>
Date: Wed, 22 Nov 1995 09:55:22 +1300

> I have wu-ftpd-2.4 running on SunOS 4.1.1.  Everything is fine until
 > I NFS mount a partition under an upload directory.  The files intended
 > to land there pass OK according to the client (successful upload messages)
 > but the directory ends up with a zero-length file with the chown/chmod
 > performed as prescribed in ftpaccess.  If I umount that NFS dir and upload
 > direct to local disk, it works fine.
 > 
 > Has anyone seen this? Fixes?  I scanned the archives without success.
 > Thanks in advance!

 I have posted about this twice -- No success -- If you get an answer
 PLEASE let me know.

 My symptoms sound like yours

	- Works fine with a local disk
	- can write as root to the NFS disk (so is allowed by exports)
	- Get an empty file when trying to upload.
	- Get an NFS write error 13 (permission denied) in /var/adm/messages

 My workaround was a hack but anyway

 make the upload directory chown to ftp and mode 000 !!!
 people can then write to it -- can't read it because of the mode
 and can't overwrite it because wu-ftpd won't allow it. It does
 mean however that a person of privilage must be around to get it out
 of the directory

 The problem is in the wu-ftpd as far as I can tell -- root can write to
 the NFS directory but can't going through wu-ftpd

 Pete

Peter Glassenbury   ([email-masked])
Dept. of Computer Science, University of Canterbury, Christchurch, New Zealand

---

From: Keith Pilotti <[email-masked]>
Date: Tue, 21 Nov 1995 13:48:57 -0800

> 	- can write as root to the NFS disk (so is allowed by exports)

Can you write as user "ftp" to the NFS disk?

  >  the NFS directory but can't going through wu-ftpd

Yes, but wu-ftpd does not have root permissions at that point.  The directory 
must be writable by user 'ftp' (either through ownership, or in the case of 
the typical 'incoming/upload' directory through world writability).

This is what I use on my Solaris2.4 system:

upload  /usr/spool/ftp  /pub/incoming           yes root   users   0640 nodirs

drwxrwx-wx   2 root     users        512 Nov 21 03:48 incoming

+Keith

--
Keith F. Pilotti                                [email-masked]
QUALCOMM Incorporated                           UNIX Computer Support Team
6455 Lusk Boulevard                             +1 619 658-4555 (Voice)
San Diego, CA 92121-2779                        +1 619 658-2115 (FAX)

---

From: Tim Villa - ECS <[email-masked]>
Date: Wed, 22 Nov 1995 08:35:07 +0800 (WST)

> 	- can write as root to the NFS disk (so is allowed by exports)

I suspect this is the problem in the first poster's case.  Make sure the
exporting machine has allowed write access to the shared disk, and that
wuftpd is running with the appropriate priveleges.  Not even root can
write the disk if the server doesn't allow it.

Tim
-- 
Tim Villa                   Faculties of Economics & Commerce, Education and Law
Network/Systems officer            The University of Western Australia     _-@
Phone: +61-9-380-1796                              Fax: +61-9-380-1068  --\ \,)
email: [email-masked]              http://www.ecel.uwa.edu.au/tim  (*)'~(*)